git-rebase--interactive.shon commit rebase -i: introduce --recreate-merges=[no-]rebase-cousins (5e05825)
   1# This shell script fragment is sourced by git-rebase to implement
   2# its interactive mode.  "git rebase --interactive" makes it easy
   3# to fix up commits in the middle of a series and rearrange commits.
   4#
   5# Copyright (c) 2006 Johannes E. Schindelin
   6#
   7# The original idea comes from Eric W. Biederman, in
   8# https://public-inbox.org/git/m1odwkyuf5.fsf_-_@ebiederm.dsl.xmission.com/
   9#
  10# The file containing rebase commands, comments, and empty lines.
  11# This file is created by "git rebase -i" then edited by the user.  As
  12# the lines are processed, they are removed from the front of this
  13# file and written to the tail of $done.
  14todo="$state_dir"/git-rebase-todo
  15
  16# The rebase command lines that have already been processed.  A line
  17# is moved here when it is first handled, before any associated user
  18# actions.
  19done="$state_dir"/done
  20
  21# The commit message that is planned to be used for any changes that
  22# need to be committed following a user interaction.
  23msg="$state_dir"/message
  24
  25# The file into which is accumulated the suggested commit message for
  26# squash/fixup commands.  When the first of a series of squash/fixups
  27# is seen, the file is created and the commit message from the
  28# previous commit and from the first squash/fixup commit are written
  29# to it.  The commit message for each subsequent squash/fixup commit
  30# is appended to the file as it is processed.
  31#
  32# The first line of the file is of the form
  33#     # This is a combination of $count commits.
  34# where $count is the number of commits whose messages have been
  35# written to the file so far (including the initial "pick" commit).
  36# Each time that a commit message is processed, this line is read and
  37# updated.  It is deleted just before the combined commit is made.
  38squash_msg="$state_dir"/message-squash
  39
  40# If the current series of squash/fixups has not yet included a squash
  41# command, then this file exists and holds the commit message of the
  42# original "pick" commit.  (If the series ends without a "squash"
  43# command, then this can be used as the commit message of the combined
  44# commit without opening the editor.)
  45fixup_msg="$state_dir"/message-fixup
  46
  47# $rewritten is the name of a directory containing files for each
  48# commit that is reachable by at least one merge base of $head and
  49# $upstream. They are not necessarily rewritten, but their children
  50# might be.  This ensures that commits on merged, but otherwise
  51# unrelated side branches are left alone. (Think "X" in the man page's
  52# example.)
  53rewritten="$state_dir"/rewritten
  54
  55dropped="$state_dir"/dropped
  56
  57end="$state_dir"/end
  58msgnum="$state_dir"/msgnum
  59
  60# A script to set the GIT_AUTHOR_NAME, GIT_AUTHOR_EMAIL, and
  61# GIT_AUTHOR_DATE that will be used for the commit that is currently
  62# being rebased.
  63author_script="$state_dir"/author-script
  64
  65# When an "edit" rebase command is being processed, the SHA1 of the
  66# commit to be edited is recorded in this file.  When "git rebase
  67# --continue" is executed, if there are any staged changes then they
  68# will be amended to the HEAD commit, but only provided the HEAD
  69# commit is still the commit to be edited.  When any other rebase
  70# command is processed, this file is deleted.
  71amend="$state_dir"/amend
  72
  73# For the post-rewrite hook, we make a list of rewritten commits and
  74# their new sha1s.  The rewritten-pending list keeps the sha1s of
  75# commits that have been processed, but not committed yet,
  76# e.g. because they are waiting for a 'squash' command.
  77rewritten_list="$state_dir"/rewritten-list
  78rewritten_pending="$state_dir"/rewritten-pending
  79
  80# Work around Git for Windows' Bash whose "read" does not strip CRLF
  81# and leaves CR at the end instead.
  82cr=$(printf "\015")
  83
  84strategy_args=${strategy:+--strategy=$strategy}
  85test -n "$strategy_opts" &&
  86eval '
  87        for strategy_opt in '"$strategy_opts"'
  88        do
  89                strategy_args="$strategy_args -X$(git rev-parse --sq-quote "${strategy_opt#--}")"
  90        done
  91'
  92
  93GIT_CHERRY_PICK_HELP="$resolvemsg"
  94export GIT_CHERRY_PICK_HELP
  95
  96comment_char=$(git config --get core.commentchar 2>/dev/null)
  97case "$comment_char" in
  98'' | auto)
  99        comment_char="#"
 100        ;;
 101?)
 102        ;;
 103*)
 104        comment_char=$(echo "$comment_char" | cut -c1)
 105        ;;
 106esac
 107
 108warn () {
 109        printf '%s\n' "$*" >&2
 110}
 111
 112# Output the commit message for the specified commit.
 113commit_message () {
 114        git cat-file commit "$1" | sed "1,/^$/d"
 115}
 116
 117orig_reflog_action="$GIT_REFLOG_ACTION"
 118
 119comment_for_reflog () {
 120        case "$orig_reflog_action" in
 121        ''|rebase*)
 122                GIT_REFLOG_ACTION="rebase -i ($1)"
 123                export GIT_REFLOG_ACTION
 124                ;;
 125        esac
 126}
 127
 128last_count=
 129mark_action_done () {
 130        sed -e 1q < "$todo" >> "$done"
 131        sed -e 1d < "$todo" >> "$todo".new
 132        mv -f "$todo".new "$todo"
 133        new_count=$(( $(git stripspace --strip-comments <"$done" | wc -l) ))
 134        echo $new_count >"$msgnum"
 135        total=$(($new_count + $(git stripspace --strip-comments <"$todo" | wc -l)))
 136        echo $total >"$end"
 137        if test "$last_count" != "$new_count"
 138        then
 139                last_count=$new_count
 140                eval_gettext "Rebasing (\$new_count/\$total)"; printf "\r"
 141                test -z "$verbose" || echo
 142        fi
 143}
 144
 145# Put the last action marked done at the beginning of the todo list
 146# again. If there has not been an action marked done yet, leave the list of
 147# items on the todo list unchanged.
 148reschedule_last_action () {
 149        tail -n 1 "$done" | cat - "$todo" >"$todo".new
 150        sed -e \$d <"$done" >"$done".new
 151        mv -f "$todo".new "$todo"
 152        mv -f "$done".new "$done"
 153}
 154
 155append_todo_help () {
 156        gettext "
 157Commands:
 158p, pick <commit> = use commit
 159r, reword <commit> = use commit, but edit the commit message
 160e, edit <commit> = use commit, but stop for amending
 161s, squash <commit> = use commit, but meld into previous commit
 162f, fixup <commit> = like \"squash\", but discard this commit's log message
 163x, exec <commit> = run command (the rest of the line) using shell
 164d, drop <commit> = remove commit
 165l, label <label> = label current HEAD with a name
 166t, reset <label> = reset HEAD to a label
 167m, merge [-C <commit> | -c <commit>] <label> [# <oneline>]
 168.       create a merge commit using the original merge commit's
 169.       message (or the oneline, if no original merge commit was
 170.       specified). Use -c <commit> to reword the commit message.
 171
 172These lines can be re-ordered; they are executed from top to bottom.
 173" | git stripspace --comment-lines >>"$todo"
 174
 175        if test $(get_missing_commit_check_level) = error
 176        then
 177                gettext "
 178Do not remove any line. Use 'drop' explicitly to remove a commit.
 179" | git stripspace --comment-lines >>"$todo"
 180        else
 181                gettext "
 182If you remove a line here THAT COMMIT WILL BE LOST.
 183" | git stripspace --comment-lines >>"$todo"
 184        fi
 185}
 186
 187make_patch () {
 188        sha1_and_parents="$(git rev-list --parents -1 "$1")"
 189        case "$sha1_and_parents" in
 190        ?*' '?*' '?*)
 191                git diff --cc $sha1_and_parents
 192                ;;
 193        ?*' '?*)
 194                git diff-tree -p "$1^!"
 195                ;;
 196        *)
 197                echo "Root commit"
 198                ;;
 199        esac > "$state_dir"/patch
 200        test -f "$msg" ||
 201                commit_message "$1" > "$msg"
 202        test -f "$author_script" ||
 203                get_author_ident_from_commit "$1" > "$author_script"
 204}
 205
 206die_with_patch () {
 207        echo "$1" > "$state_dir"/stopped-sha
 208        make_patch "$1"
 209        die "$2"
 210}
 211
 212exit_with_patch () {
 213        echo "$1" > "$state_dir"/stopped-sha
 214        make_patch $1
 215        git rev-parse --verify HEAD > "$amend"
 216        gpg_sign_opt_quoted=${gpg_sign_opt:+$(git rev-parse --sq-quote "$gpg_sign_opt")}
 217        warn "$(eval_gettext "\
 218You can amend the commit now, with
 219
 220        git commit --amend \$gpg_sign_opt_quoted
 221
 222Once you are satisfied with your changes, run
 223
 224        git rebase --continue")"
 225        warn
 226        exit $2
 227}
 228
 229die_abort () {
 230        apply_autostash
 231        rm -rf "$state_dir"
 232        die "$1"
 233}
 234
 235has_action () {
 236        test -n "$(git stripspace --strip-comments <"$1")"
 237}
 238
 239is_empty_commit() {
 240        tree=$(git rev-parse -q --verify "$1"^{tree} 2>/dev/null) || {
 241                sha1=$1
 242                die "$(eval_gettext "\$sha1: not a commit that can be picked")"
 243        }
 244        ptree=$(git rev-parse -q --verify "$1"^^{tree} 2>/dev/null) ||
 245                ptree=4b825dc642cb6eb9a060e54bf8d69288fbee4904
 246        test "$tree" = "$ptree"
 247}
 248
 249is_merge_commit()
 250{
 251        git rev-parse --verify --quiet "$1"^2 >/dev/null 2>&1
 252}
 253
 254# Run command with GIT_AUTHOR_NAME, GIT_AUTHOR_EMAIL, and
 255# GIT_AUTHOR_DATE exported from the current environment.
 256do_with_author () {
 257        (
 258                export GIT_AUTHOR_NAME GIT_AUTHOR_EMAIL GIT_AUTHOR_DATE
 259                "$@"
 260        )
 261}
 262
 263git_sequence_editor () {
 264        if test -z "$GIT_SEQUENCE_EDITOR"
 265        then
 266                GIT_SEQUENCE_EDITOR="$(git config sequence.editor)"
 267                if [ -z "$GIT_SEQUENCE_EDITOR" ]
 268                then
 269                        GIT_SEQUENCE_EDITOR="$(git var GIT_EDITOR)" || return $?
 270                fi
 271        fi
 272
 273        eval "$GIT_SEQUENCE_EDITOR" '"$@"'
 274}
 275
 276pick_one () {
 277        ff=--ff
 278
 279        case "$1" in -n) sha1=$2; ff= ;; *) sha1=$1 ;; esac
 280        case "$force_rebase" in '') ;; ?*) ff= ;; esac
 281        output git rev-parse --verify $sha1 || die "$(eval_gettext "Invalid commit name: \$sha1")"
 282
 283        if is_empty_commit "$sha1"
 284        then
 285                empty_args="--allow-empty"
 286        fi
 287
 288        test -d "$rewritten" &&
 289                pick_one_preserving_merges "$@" && return
 290        output eval git cherry-pick $allow_rerere_autoupdate \
 291                        ${gpg_sign_opt:+$(git rev-parse --sq-quote "$gpg_sign_opt")} \
 292                        "$strategy_args" $empty_args $ff "$@"
 293
 294        # If cherry-pick dies it leaves the to-be-picked commit unrecorded. Reschedule
 295        # previous task so this commit is not lost.
 296        ret=$?
 297        case "$ret" in [01]) ;; *) reschedule_last_action ;; esac
 298        return $ret
 299}
 300
 301pick_one_preserving_merges () {
 302        fast_forward=t
 303        case "$1" in
 304        -n)
 305                fast_forward=f
 306                sha1=$2
 307                ;;
 308        *)
 309                sha1=$1
 310                ;;
 311        esac
 312        sha1=$(git rev-parse $sha1)
 313
 314        if test -f "$state_dir"/current-commit
 315        then
 316                if test "$fast_forward" = t
 317                then
 318                        while read current_commit
 319                        do
 320                                git rev-parse HEAD > "$rewritten"/$current_commit
 321                        done <"$state_dir"/current-commit
 322                        rm "$state_dir"/current-commit ||
 323                                die "$(gettext "Cannot write current commit's replacement sha1")"
 324                fi
 325        fi
 326
 327        echo $sha1 >> "$state_dir"/current-commit
 328
 329        # rewrite parents; if none were rewritten, we can fast-forward.
 330        new_parents=
 331        pend=" $(git rev-list --parents -1 $sha1 | cut -d' ' -s -f2-)"
 332        if test "$pend" = " "
 333        then
 334                pend=" root"
 335        fi
 336        while [ "$pend" != "" ]
 337        do
 338                p=$(expr "$pend" : ' \([^ ]*\)')
 339                pend="${pend# $p}"
 340
 341                if test -f "$rewritten"/$p
 342                then
 343                        new_p=$(cat "$rewritten"/$p)
 344
 345                        # If the todo reordered commits, and our parent is marked for
 346                        # rewriting, but hasn't been gotten to yet, assume the user meant to
 347                        # drop it on top of the current HEAD
 348                        if test -z "$new_p"
 349                        then
 350                                new_p=$(git rev-parse HEAD)
 351                        fi
 352
 353                        test $p != $new_p && fast_forward=f
 354                        case "$new_parents" in
 355                        *$new_p*)
 356                                ;; # do nothing; that parent is already there
 357                        *)
 358                                new_parents="$new_parents $new_p"
 359                                ;;
 360                        esac
 361                else
 362                        if test -f "$dropped"/$p
 363                        then
 364                                fast_forward=f
 365                                replacement="$(cat "$dropped"/$p)"
 366                                test -z "$replacement" && replacement=root
 367                                pend=" $replacement$pend"
 368                        else
 369                                new_parents="$new_parents $p"
 370                        fi
 371                fi
 372        done
 373        case $fast_forward in
 374        t)
 375                output warn "$(eval_gettext "Fast-forward to \$sha1")"
 376                output git reset --hard $sha1 ||
 377                        die "$(eval_gettext "Cannot fast-forward to \$sha1")"
 378                ;;
 379        f)
 380                first_parent=$(expr "$new_parents" : ' \([^ ]*\)')
 381
 382                if [ "$1" != "-n" ]
 383                then
 384                        # detach HEAD to current parent
 385                        output git checkout $first_parent 2> /dev/null ||
 386                                die "$(eval_gettext "Cannot move HEAD to \$first_parent")"
 387                fi
 388
 389                case "$new_parents" in
 390                ' '*' '*)
 391                        test "a$1" = a-n && die "$(eval_gettext "Refusing to squash a merge: \$sha1")"
 392
 393                        # redo merge
 394                        author_script_content=$(get_author_ident_from_commit $sha1)
 395                        eval "$author_script_content"
 396                        msg_content="$(commit_message $sha1)"
 397                        # No point in merging the first parent, that's HEAD
 398                        new_parents=${new_parents# $first_parent}
 399                        merge_args="--no-log --no-ff"
 400                        if ! do_with_author output eval \
 401                                git merge ${gpg_sign_opt:+$(git rev-parse \
 402                                        --sq-quote "$gpg_sign_opt")} \
 403                                $allow_rerere_autoupdate "$merge_args" \
 404                                "$strategy_args" \
 405                                -m $(git rev-parse --sq-quote "$msg_content") \
 406                                "$new_parents"
 407                        then
 408                                printf "%s\n" "$msg_content" > "$GIT_DIR"/MERGE_MSG
 409                                die_with_patch $sha1 "$(eval_gettext "Error redoing merge \$sha1")"
 410                        fi
 411                        echo "$sha1 $(git rev-parse HEAD^0)" >> "$rewritten_list"
 412                        ;;
 413                *)
 414                        output eval git cherry-pick $allow_rerere_autoupdate \
 415                                ${gpg_sign_opt:+$(git rev-parse --sq-quote "$gpg_sign_opt")} \
 416                                "$strategy_args" "$@" ||
 417                                die_with_patch $sha1 "$(eval_gettext "Could not pick \$sha1")"
 418                        ;;
 419                esac
 420                ;;
 421        esac
 422}
 423
 424this_nth_commit_message () {
 425        n=$1
 426        eval_gettext "This is the commit message #\${n}:"
 427}
 428
 429skip_nth_commit_message () {
 430        n=$1
 431        eval_gettext "The commit message #\${n} will be skipped:"
 432}
 433
 434update_squash_messages () {
 435        if test -f "$squash_msg"; then
 436                mv "$squash_msg" "$squash_msg".bak || exit
 437                count=$(($(sed -n \
 438                        -e "1s/^$comment_char[^0-9]*\([0-9][0-9]*\).*/\1/p" \
 439                        -e "q" < "$squash_msg".bak)+1))
 440                {
 441                        printf '%s\n' "$comment_char $(eval_ngettext \
 442                                "This is a combination of \$count commit." \
 443                                "This is a combination of \$count commits." \
 444                                $count)"
 445                        sed -e 1d -e '2,/^./{
 446                                /^$/d
 447                        }' <"$squash_msg".bak
 448                } >"$squash_msg"
 449        else
 450                commit_message HEAD >"$fixup_msg" ||
 451                die "$(eval_gettext "Cannot write \$fixup_msg")"
 452                count=2
 453                {
 454                        printf '%s\n' "$comment_char $(gettext "This is a combination of 2 commits.")"
 455                        printf '%s\n' "$comment_char $(gettext "This is the 1st commit message:")"
 456                        echo
 457                        cat "$fixup_msg"
 458                } >"$squash_msg"
 459        fi
 460        case $1 in
 461        squash)
 462                rm -f "$fixup_msg"
 463                echo
 464                printf '%s\n' "$comment_char $(this_nth_commit_message $count)"
 465                echo
 466                commit_message $2
 467                ;;
 468        fixup)
 469                echo
 470                printf '%s\n' "$comment_char $(skip_nth_commit_message $count)"
 471                echo
 472                # Change the space after the comment character to TAB:
 473                commit_message $2 | git stripspace --comment-lines | sed -e 's/ /       /'
 474                ;;
 475        esac >>"$squash_msg"
 476}
 477
 478peek_next_command () {
 479        git stripspace --strip-comments <"$todo" | sed -n -e 's/ .*//p' -e q
 480}
 481
 482# A squash/fixup has failed.  Prepare the long version of the squash
 483# commit message, then die_with_patch.  This code path requires the
 484# user to edit the combined commit message for all commits that have
 485# been squashed/fixedup so far.  So also erase the old squash
 486# messages, effectively causing the combined commit to be used as the
 487# new basis for any further squash/fixups.  Args: sha1 rest
 488die_failed_squash() {
 489        sha1=$1
 490        rest=$2
 491        mv "$squash_msg" "$msg" || exit
 492        rm -f "$fixup_msg"
 493        cp "$msg" "$GIT_DIR"/MERGE_MSG || exit
 494        warn
 495        warn "$(eval_gettext "Could not apply \$sha1... \$rest")"
 496        die_with_patch $sha1 ""
 497}
 498
 499flush_rewritten_pending() {
 500        test -s "$rewritten_pending" || return
 501        newsha1="$(git rev-parse HEAD^0)"
 502        sed "s/$/ $newsha1/" < "$rewritten_pending" >> "$rewritten_list"
 503        rm -f "$rewritten_pending"
 504}
 505
 506record_in_rewritten() {
 507        oldsha1="$(git rev-parse $1)"
 508        echo "$oldsha1" >> "$rewritten_pending"
 509
 510        case "$(peek_next_command)" in
 511        squash|s|fixup|f)
 512                ;;
 513        *)
 514                flush_rewritten_pending
 515                ;;
 516        esac
 517}
 518
 519do_pick () {
 520        sha1=$1
 521        rest=$2
 522        if test "$(git rev-parse HEAD)" = "$squash_onto"
 523        then
 524                # Set the correct commit message and author info on the
 525                # sentinel root before cherry-picking the original changes
 526                # without committing (-n).  Finally, update the sentinel again
 527                # to include these changes.  If the cherry-pick results in a
 528                # conflict, this means our behaviour is similar to a standard
 529                # failed cherry-pick during rebase, with a dirty index to
 530                # resolve before manually running git commit --amend then git
 531                # rebase --continue.
 532                git commit --allow-empty --allow-empty-message --amend \
 533                           --no-post-rewrite -n -q -C $sha1 &&
 534                        pick_one -n $sha1 &&
 535                        git commit --allow-empty --allow-empty-message \
 536                                   --amend --no-post-rewrite -n -q -C $sha1 \
 537                                   ${gpg_sign_opt:+"$gpg_sign_opt"} ||
 538                                   die_with_patch $sha1 "$(eval_gettext "Could not apply \$sha1... \$rest")"
 539        else
 540                pick_one $sha1 ||
 541                        die_with_patch $sha1 "$(eval_gettext "Could not apply \$sha1... \$rest")"
 542        fi
 543}
 544
 545do_next () {
 546        rm -f "$msg" "$author_script" "$amend" "$state_dir"/stopped-sha || exit
 547        read -r command sha1 rest < "$todo"
 548        case "$command" in
 549        "$comment_char"*|''|noop|drop|d)
 550                mark_action_done
 551                ;;
 552        "$cr")
 553                # Work around CR left by "read" (e.g. with Git for Windows' Bash).
 554                mark_action_done
 555                ;;
 556        pick|p)
 557                comment_for_reflog pick
 558
 559                mark_action_done
 560                do_pick $sha1 "$rest"
 561                record_in_rewritten $sha1
 562                ;;
 563        reword|r)
 564                comment_for_reflog reword
 565
 566                mark_action_done
 567                do_pick $sha1 "$rest"
 568                git commit --amend --no-post-rewrite ${gpg_sign_opt:+"$gpg_sign_opt"} || {
 569                        warn "$(eval_gettext "\
 570Could not amend commit after successfully picking \$sha1... \$rest
 571This is most likely due to an empty commit message, or the pre-commit hook
 572failed. If the pre-commit hook failed, you may need to resolve the issue before
 573you are able to reword the commit.")"
 574                        exit_with_patch $sha1 1
 575                }
 576                record_in_rewritten $sha1
 577                ;;
 578        edit|e)
 579                comment_for_reflog edit
 580
 581                mark_action_done
 582                do_pick $sha1 "$rest"
 583                sha1_abbrev=$(git rev-parse --short $sha1)
 584                warn "$(eval_gettext "Stopped at \$sha1_abbrev... \$rest")"
 585                exit_with_patch $sha1 0
 586                ;;
 587        squash|s|fixup|f)
 588                case "$command" in
 589                squash|s)
 590                        squash_style=squash
 591                        ;;
 592                fixup|f)
 593                        squash_style=fixup
 594                        ;;
 595                esac
 596                comment_for_reflog $squash_style
 597
 598                test -f "$done" && has_action "$done" ||
 599                        die "$(eval_gettext "Cannot '\$squash_style' without a previous commit")"
 600
 601                mark_action_done
 602                update_squash_messages $squash_style $sha1
 603                author_script_content=$(get_author_ident_from_commit HEAD)
 604                echo "$author_script_content" > "$author_script"
 605                eval "$author_script_content"
 606                if ! pick_one -n $sha1
 607                then
 608                        git rev-parse --verify HEAD >"$amend"
 609                        die_failed_squash $sha1 "$rest"
 610                fi
 611                case "$(peek_next_command)" in
 612                squash|s|fixup|f)
 613                        # This is an intermediate commit; its message will only be
 614                        # used in case of trouble.  So use the long version:
 615                        do_with_author output git commit --amend --no-verify -F "$squash_msg" \
 616                                ${gpg_sign_opt:+"$gpg_sign_opt"} ||
 617                                die_failed_squash $sha1 "$rest"
 618                        ;;
 619                *)
 620                        # This is the final command of this squash/fixup group
 621                        if test -f "$fixup_msg"
 622                        then
 623                                do_with_author git commit --amend --no-verify -F "$fixup_msg" \
 624                                        ${gpg_sign_opt:+"$gpg_sign_opt"} ||
 625                                        die_failed_squash $sha1 "$rest"
 626                        else
 627                                cp "$squash_msg" "$GIT_DIR"/SQUASH_MSG || exit
 628                                rm -f "$GIT_DIR"/MERGE_MSG
 629                                do_with_author git commit --amend --no-verify -F "$GIT_DIR"/SQUASH_MSG -e \
 630                                        ${gpg_sign_opt:+"$gpg_sign_opt"} ||
 631                                        die_failed_squash $sha1 "$rest"
 632                        fi
 633                        rm -f "$squash_msg" "$fixup_msg"
 634                        ;;
 635                esac
 636                record_in_rewritten $sha1
 637                ;;
 638        x|"exec")
 639                read -r command rest < "$todo"
 640                mark_action_done
 641                eval_gettextln "Executing: \$rest"
 642                "${SHELL:-@SHELL_PATH@}" -c "$rest" # Actual execution
 643                status=$?
 644                # Run in subshell because require_clean_work_tree can die.
 645                dirty=f
 646                (require_clean_work_tree "rebase" 2>/dev/null) || dirty=t
 647                if test "$status" -ne 0
 648                then
 649                        warn "$(eval_gettext "Execution failed: \$rest")"
 650                        test "$dirty" = f ||
 651                                warn "$(gettext "and made changes to the index and/or the working tree")"
 652
 653                        warn "$(gettext "\
 654You can fix the problem, and then run
 655
 656        git rebase --continue")"
 657                        warn
 658                        if test $status -eq 127         # command not found
 659                        then
 660                                status=1
 661                        fi
 662                        exit "$status"
 663                elif test "$dirty" = t
 664                then
 665                        # TRANSLATORS: after these lines is a command to be issued by the user
 666                        warn "$(eval_gettext "\
 667Execution succeeded: \$rest
 668but left changes to the index and/or the working tree
 669Commit or stash your changes, and then run
 670
 671        git rebase --continue")"
 672                        warn
 673                        exit 1
 674                fi
 675                ;;
 676        *)
 677                warn "$(eval_gettext "Unknown command: \$command \$sha1 \$rest")"
 678                fixtodo="$(gettext "Please fix this using 'git rebase --edit-todo'.")"
 679                if git rev-parse --verify -q "$sha1" >/dev/null
 680                then
 681                        die_with_patch $sha1 "$fixtodo"
 682                else
 683                        die "$fixtodo"
 684                fi
 685                ;;
 686        esac
 687        test -s "$todo" && return
 688
 689        comment_for_reflog finish &&
 690        newhead=$(git rev-parse HEAD) &&
 691        case $head_name in
 692        refs/*)
 693                message="$GIT_REFLOG_ACTION: $head_name onto $onto" &&
 694                git update-ref -m "$message" $head_name $newhead $orig_head &&
 695                git symbolic-ref \
 696                  -m "$GIT_REFLOG_ACTION: returning to $head_name" \
 697                  HEAD $head_name
 698                ;;
 699        esac && {
 700                test ! -f "$state_dir"/verbose ||
 701                        git diff-tree --stat $orig_head..HEAD
 702        } &&
 703        {
 704                test -s "$rewritten_list" &&
 705                git notes copy --for-rewrite=rebase < "$rewritten_list" ||
 706                true # we don't care if this copying failed
 707        } &&
 708        hook="$(git rev-parse --git-path hooks/post-rewrite)"
 709        if test -x "$hook" && test -s "$rewritten_list"; then
 710                "$hook" rebase < "$rewritten_list"
 711                true # we don't care if this hook failed
 712        fi &&
 713                warn "$(eval_gettext "Successfully rebased and updated \$head_name.")"
 714
 715        return 1 # not failure; just to break the do_rest loop
 716}
 717
 718# can only return 0, when the infinite loop breaks
 719do_rest () {
 720        while :
 721        do
 722                do_next || break
 723        done
 724}
 725
 726expand_todo_ids() {
 727        git rebase--helper --expand-ids
 728}
 729
 730collapse_todo_ids() {
 731        git rebase--helper --shorten-ids
 732}
 733
 734# Switch to the branch in $into and notify it in the reflog
 735checkout_onto () {
 736        GIT_REFLOG_ACTION="$GIT_REFLOG_ACTION: checkout $onto_name"
 737        output git checkout $onto || die_abort "$(gettext "could not detach HEAD")"
 738        git update-ref ORIG_HEAD $orig_head
 739}
 740
 741get_missing_commit_check_level () {
 742        check_level=$(git config --get rebase.missingCommitsCheck)
 743        check_level=${check_level:-ignore}
 744        # Don't be case sensitive
 745        printf '%s' "$check_level" | tr 'A-Z' 'a-z'
 746}
 747
 748# The whole contents of this file is run by dot-sourcing it from
 749# inside a shell function.  It used to be that "return"s we see
 750# below were not inside any function, and expected to return
 751# to the function that dot-sourced us.
 752#
 753# However, older (9.x) versions of FreeBSD /bin/sh misbehave on such a
 754# construct and continue to run the statements that follow such a "return".
 755# As a work-around, we introduce an extra layer of a function
 756# here, and immediately call it after defining it.
 757git_rebase__interactive () {
 758
 759case "$action" in
 760continue)
 761        if test ! -d "$rewritten"
 762        then
 763                exec git rebase--helper ${force_rebase:+--no-ff} --continue
 764        fi
 765        # do we have anything to commit?
 766        if git diff-index --cached --quiet HEAD --
 767        then
 768                # Nothing to commit -- skip this commit
 769
 770                test ! -f "$GIT_DIR"/CHERRY_PICK_HEAD ||
 771                rm "$GIT_DIR"/CHERRY_PICK_HEAD ||
 772                die "$(gettext "Could not remove CHERRY_PICK_HEAD")"
 773        else
 774                if ! test -f "$author_script"
 775                then
 776                        gpg_sign_opt_quoted=${gpg_sign_opt:+$(git rev-parse --sq-quote "$gpg_sign_opt")}
 777                        die "$(eval_gettext "\
 778You have staged changes in your working tree.
 779If these changes are meant to be
 780squashed into the previous commit, run:
 781
 782  git commit --amend \$gpg_sign_opt_quoted
 783
 784If they are meant to go into a new commit, run:
 785
 786  git commit \$gpg_sign_opt_quoted
 787
 788In both cases, once you're done, continue with:
 789
 790  git rebase --continue
 791")"
 792                fi
 793                . "$author_script" ||
 794                        die "$(gettext "Error trying to find the author identity to amend commit")"
 795                if test -f "$amend"
 796                then
 797                        current_head=$(git rev-parse --verify HEAD)
 798                        test "$current_head" = $(cat "$amend") ||
 799                        die "$(gettext "\
 800You have uncommitted changes in your working tree. Please commit them
 801first and then run 'git rebase --continue' again.")"
 802                        do_with_author git commit --amend --no-verify -F "$msg" -e \
 803                                ${gpg_sign_opt:+"$gpg_sign_opt"} ||
 804                                die "$(gettext "Could not commit staged changes.")"
 805                else
 806                        do_with_author git commit --no-verify -F "$msg" -e \
 807                                ${gpg_sign_opt:+"$gpg_sign_opt"} ||
 808                                die "$(gettext "Could not commit staged changes.")"
 809                fi
 810        fi
 811
 812        if test -r "$state_dir"/stopped-sha
 813        then
 814                record_in_rewritten "$(cat "$state_dir"/stopped-sha)"
 815        fi
 816
 817        require_clean_work_tree "rebase"
 818        do_rest
 819        return 0
 820        ;;
 821skip)
 822        git rerere clear
 823
 824        if test ! -d "$rewritten"
 825        then
 826                exec git rebase--helper ${force_rebase:+--no-ff} --continue
 827        fi
 828        do_rest
 829        return 0
 830        ;;
 831edit-todo)
 832        git stripspace --strip-comments <"$todo" >"$todo".new
 833        mv -f "$todo".new "$todo"
 834        collapse_todo_ids
 835        append_todo_help
 836        gettext "
 837You are editing the todo file of an ongoing interactive rebase.
 838To continue rebase after editing, run:
 839    git rebase --continue
 840
 841" | git stripspace --comment-lines >>"$todo"
 842
 843        git_sequence_editor "$todo" ||
 844                die "$(gettext "Could not execute editor")"
 845        expand_todo_ids
 846
 847        exit
 848        ;;
 849esac
 850
 851comment_for_reflog start
 852
 853if test ! -z "$switch_to"
 854then
 855        GIT_REFLOG_ACTION="$GIT_REFLOG_ACTION: checkout $switch_to"
 856        output git checkout "$switch_to" -- ||
 857                die "$(eval_gettext "Could not checkout \$switch_to")"
 858
 859        comment_for_reflog start
 860fi
 861
 862orig_head=$(git rev-parse --verify HEAD) || die "$(gettext "No HEAD?")"
 863mkdir -p "$state_dir" || die "$(eval_gettext "Could not create temporary \$state_dir")"
 864
 865: > "$state_dir"/interactive || die "$(gettext "Could not mark as interactive")"
 866write_basic_state
 867if test t = "$preserve_merges"
 868then
 869        if test -z "$rebase_root"
 870        then
 871                mkdir "$rewritten" &&
 872                for c in $(git merge-base --all $orig_head $upstream)
 873                do
 874                        echo $onto > "$rewritten"/$c ||
 875                                die "$(gettext "Could not init rewritten commits")"
 876                done
 877        else
 878                mkdir "$rewritten" &&
 879                echo $onto > "$rewritten"/root ||
 880                        die "$(gettext "Could not init rewritten commits")"
 881        fi
 882        # No cherry-pick because our first pass is to determine
 883        # parents to rewrite and skipping dropped commits would
 884        # prematurely end our probe
 885        merges_option=
 886else
 887        merges_option="--no-merges --cherry-pick"
 888fi
 889
 890shorthead=$(git rev-parse --short $orig_head)
 891shortonto=$(git rev-parse --short $onto)
 892if test -z "$rebase_root"
 893        # this is now equivalent to ! -z "$upstream"
 894then
 895        shortupstream=$(git rev-parse --short $upstream)
 896        revisions=$upstream...$orig_head
 897        shortrevisions=$shortupstream..$shorthead
 898else
 899        revisions=$onto...$orig_head
 900        shortrevisions=$shorthead
 901fi
 902if test t != "$preserve_merges"
 903then
 904        git rebase--helper --make-script ${keep_empty:+--keep-empty} \
 905                ${recreate_merges:+--recreate-merges} \
 906                ${rebase_cousins:+--rebase-cousins} \
 907                $revisions ${restrict_revision+^$restrict_revision} >"$todo" ||
 908        die "$(gettext "Could not generate todo list")"
 909else
 910        format=$(git config --get rebase.instructionFormat)
 911        # the 'rev-list .. | sed' requires %m to parse; the instruction requires %H to parse
 912        git rev-list $merges_option --format="%m%H ${format:-%s}" \
 913                --reverse --left-right --topo-order \
 914                $revisions ${restrict_revision+^$restrict_revision} | \
 915                sed -n "s/^>//p" |
 916        while read -r sha1 rest
 917        do
 918
 919                if test -z "$keep_empty" && is_empty_commit $sha1 && ! is_merge_commit $sha1
 920                then
 921                        comment_out="$comment_char "
 922                else
 923                        comment_out=
 924                fi
 925
 926                if test -z "$rebase_root"
 927                then
 928                        preserve=t
 929                        for p in $(git rev-list --parents -1 $sha1 | cut -d' ' -s -f2-)
 930                        do
 931                                if test -f "$rewritten"/$p
 932                                then
 933                                        preserve=f
 934                                fi
 935                        done
 936                else
 937                        preserve=f
 938                fi
 939                if test f = "$preserve"
 940                then
 941                        touch "$rewritten"/$sha1
 942                        printf '%s\n' "${comment_out}pick $sha1 $rest" >>"$todo"
 943                fi
 944        done
 945fi
 946
 947# Watch for commits that been dropped by --cherry-pick
 948if test t = "$preserve_merges"
 949then
 950        mkdir "$dropped"
 951        # Save all non-cherry-picked changes
 952        git rev-list $revisions --left-right --cherry-pick | \
 953                sed -n "s/^>//p" > "$state_dir"/not-cherry-picks
 954        # Now all commits and note which ones are missing in
 955        # not-cherry-picks and hence being dropped
 956        git rev-list $revisions |
 957        while read rev
 958        do
 959                if test -f "$rewritten"/$rev &&
 960                   ! sane_grep "$rev" "$state_dir"/not-cherry-picks >/dev/null
 961                then
 962                        # Use -f2 because if rev-list is telling us this commit is
 963                        # not worthwhile, we don't want to track its multiple heads,
 964                        # just the history of its first-parent for others that will
 965                        # be rebasing on top of it
 966                        git rev-list --parents -1 $rev | cut -d' ' -s -f2 > "$dropped"/$rev
 967                        sha1=$(git rev-list -1 $rev)
 968                        sane_grep -v "^[a-z][a-z]* $sha1" <"$todo" > "${todo}2" ; mv "${todo}2" "$todo"
 969                        rm "$rewritten"/$rev
 970                fi
 971        done
 972fi
 973
 974test -s "$todo" || echo noop >> "$todo"
 975test -z "$autosquash" || git rebase--helper --rearrange-squash || exit
 976test -n "$cmd" && git rebase--helper --add-exec-commands "$cmd"
 977
 978todocount=$(git stripspace --strip-comments <"$todo" | wc -l)
 979todocount=${todocount##* }
 980
 981cat >>"$todo" <<EOF
 982
 983$comment_char $(eval_ngettext \
 984        "Rebase \$shortrevisions onto \$shortonto (\$todocount command)" \
 985        "Rebase \$shortrevisions onto \$shortonto (\$todocount commands)" \
 986        "$todocount")
 987EOF
 988append_todo_help
 989gettext "
 990However, if you remove everything, the rebase will be aborted.
 991
 992" | git stripspace --comment-lines >>"$todo"
 993
 994if test -z "$keep_empty"
 995then
 996        printf '%s\n' "$comment_char $(gettext "Note that empty commits are commented out")" >>"$todo"
 997fi
 998
 999
1000has_action "$todo" ||
1001        return 2
1002
1003cp "$todo" "$todo".backup
1004collapse_todo_ids
1005git_sequence_editor "$todo" ||
1006        die_abort "$(gettext "Could not execute editor")"
1007
1008has_action "$todo" ||
1009        return 2
1010
1011git rebase--helper --check-todo-list || {
1012        ret=$?
1013        checkout_onto
1014        exit $ret
1015}
1016
1017expand_todo_ids
1018
1019test -d "$rewritten" || test -n "$force_rebase" ||
1020onto="$(git rebase--helper --skip-unnecessary-picks)" ||
1021die "Could not skip unnecessary pick commands"
1022
1023checkout_onto
1024if test -z "$rebase_root" && test ! -d "$rewritten"
1025then
1026        require_clean_work_tree "rebase"
1027        exec git rebase--helper ${force_rebase:+--no-ff} --continue
1028fi
1029do_rest
1030
1031}
1032# ... and then we call the whole thing.
1033git_rebase__interactive